#if !defined( _Ji330c2Obj_h )
#define _Ji330c2Obj_h
#include "JAddObj.h"
#include "JCriticalSection.h"

#include "protocolparser/StrProtocol.h"





class 
#if defined(_EXTERNAL_DLL)
  DllExport
#else
  DllImport 
#endif
Ji330c2Obj : public JAddObj {
  protected:
    virtual void writeContent(class JOutputStream& os);
    virtual void readContent(class JDictionary& dict);
  public:
    enum {
      DATA,
      ENABLED };
	  enum {
		  VAL0, VAL1, VAL2, VAL3, VAL4, VAL5, VAL6, VAL7,
			  PROTOCOL_OUT, SECTION, STEP, LAST_VALUE };

    virtual const char* className() const;
    virtual JObject* clone() const;
    Ji330c2Obj();
    virtual void draw(JGraphics g, int x, int y, int w, int h);
	virtual int inputType( int n );
    virtual boolean inputAllowed(int n);
    virtual JString inputTag(int n);
    virtual JString outputTag(int n);
    virtual JFRect inputArea(int n);
    virtual JFRect outputArea(int n);
    virtual int inputFace(int n);
    virtual int outputFace(int n);
    virtual JFPoint inputPoint(int n, JLinkObj& link);
    virtual JFPoint outputPoint(int n, JLinkObj& link);
    virtual void engine(int n, JLinkObj& link);
    virtual JArray getProperties();
    virtual boolean updateProperty(JProperty& prop);
    virtual void access(int n, JLinkObj& link, const JDataType& data);
	void runStep();
	void processByte( int val );
  private:
	  StrProtocol* theProtocol;

    // inputs
    int data;

    // controls
    int enabled;

    // properties
    JString delimiter;
    JString protocol;

    // outputs
    int values[8];
    int protocolOut;
    int section;
    int step;
    int lastIntIn;
};


#endif
