#if !defined( _JCALObj_h )
#define _JCALObj_h
#include "JAddObj.h"
#include "JCriticalSection.h"





class 
#if defined(_EXTERNAL_DLL)
  DllExport
#else
  DllImport 
#endif
JCALObj : public JAddObj {
  protected:
  public:
    enum {
      UNCALIBRATED };

    virtual const char* className() const;
    virtual JObject* clone() const;
    JCALObj();
    virtual void draw(JGraphics g, int x, int y, int w, int h);
    virtual boolean inputAllowed(int n);
    virtual JString inputTag(int n);
    virtual JString outputTag(int n);
    virtual JFRect inputArea(int n);
    virtual JFRect outputArea(int n);
    virtual int inputFace(int n);
    virtual int outputFace(int n);
    virtual JFPoint inputPoint(int n, JLinkObj& link);
    virtual JFPoint outputPoint(int n, JLinkObj& link);
    virtual void engine(int n, JLinkObj& link);
    virtual void access(int n, JLinkObj& link, const JDataType& data);
  private:

    // inputs
    int uncalibrated;

    // outputs
    int calibrated;

	int minVal;
	int maxVal;
	int lastOutputValue;
	int count;
};


#endif
